#include "settings.h"   // header file for settings dialog box
#include <QColorDialog>

settings::settings(QWidget *parent)   // constructor for my main window
{
  setupUi(this); // this sets up GUI (all the stuff generated by Gt Designer and UIC)
  connect(pushButton_fontcolor,SIGNAL(clicked()),this,SLOT(GetFontColor()));
  comboBox_port->insertItems(0, QStringList()
#ifdef _WIN32
   << "COM1"
   << "COM2"
   << "COM3"
   << "COM4"
   << "COM5"
   << "COM6"
   << "COM7"
   << "COM8"
   << "COM9"
   << "COM10"
   << "COM11"
   << "COM12"
   << "COM13"
   << "COM14"
   << "COM15"
   << "COM16"
#else
   << "/dev/ttyS0"
   << "/dev/ttyS1"
   << "/dev/ttyS2"
   << "/dev/ttyS3"
   << "/dev/ttyS4"
   << "/dev/ttyS5"
   << "/dev/ttyS6"
   << "/dev/ttyS7"
   << "/dev/ttyUSB0"
   << "/dev/ttyUSB1"
   << "/dev/ttyUSB2"
   << "/dev/ttyUSB3"
   << "/dev/ttyUSB4"
   << "/dev/ttyUSB5"
   << "/dev/ttyUSB6"
   << "/dev/ttyUSB7"
#endif
  );
}

void settings::GetFontColor(void)
{
  QColor newcolor;

  newcolor=QColorDialog::getColor();
  if (newcolor.isValid()) {
    fontColor=newcolor.rgb()&0xffffff;
    SetButtonColor();
  }
}

void settings::setFontColor(int color)
{
  fontColor=color&0xffffff;
  SetButtonColor();
}

int settings::getFontColor(void)
{
  return fontColor;
}

void settings::SetButtonColor(void)
{
  pushButton_fontcolor->setStyleSheet(QString("background: #%1;").arg((int)fontColor,6,16,QChar('0')));
}
