#include "targetwindow.h"   // header file for target window dialog box
#include <QMessageBox>

static targetwindow *pThis;

targetwindow::targetwindow(QWidget *parent)   // constructor for my main window
{
  pThis=this; // needed to reference class member functions from outside the class
  setupUi(this); // this sets up GUI (all the stuff generated by Gt Designer and UIC)
  treeWidget_windows->setColumnWidth(0,125);
  treeWidget_windows->setColumnWidth(1,250);
  QTreeWidgetItem *newItem=new QTreeWidgetItem();
  newItem->setText(0,"title1");
  newItem->setText(1,"executable1");
  treeWidget_windows->addTopLevelItem(newItem);
  newItem=new QTreeWidgetItem();
  newItem->setText(0,"title2");
  newItem->setText(1,"executable2");
  treeWidget_windows->addTopLevelItem(newItem);
#ifndef _WIN32
  treeWidget_windows->headerItem()->setText(1, QApplication::translate("Dialog_targetwindow", "Class", 0, QApplication::UnicodeUTF8));
// linux xwindows needs display and root window
  dpy=XOpenDisplay(NULL);
  root=RootWindow(dpy,DefaultScreen(dpy));
#endif
  ListWindows();
}

#ifdef _WIN32
BOOL CALLBACK EnumTasks2(HWND hwnd, LPARAM lparam)
{
	pThis->ETasks(hwnd,lparam);
	return TRUE;
}

void targetwindow::ETasks(HWND hwnd, LPARAM lparam)
{
	char title[100];
	char path[_MAX_PATH+1];

	::GetWindowTextA(hwnd,title,sizeof(title)-1);
	if (title[0]!=0) {	// do not include tasks with blank title bar
		if (::IsWindowVisible(hwnd) && ::GetParent(hwnd)==NULL && ::IsIconic(hwnd)==0) {
//			CRemoteDlg::GetWindowModuleFileNameEx(hwnd,path,sizeof(path)-1);	// use psapi.dll only for nt/2000/xp
//			m_cWindow.InsertItem(n,title);
//			m_cWindow.SetItem(n,1,LVIF_TEXT,path,0,0,0,0);
QMessageBox::information(this,"found title",title);
		}
	}
}

void targetwindow::ListWindows(void)
{
  EnumWindows(EnumTasks2,0);
}

#else

//wrapper to avoid always having to check for null pointer
void xfree(void *ptr)
{
  if (ptr!=NULL) {
    XFree(ptr);
  }
}

void targetwindow::listallwindows(Window top)
{
  Window *children,foo;
  unsigned int nc;
  char *wname,*iname;
  XClassHint classhint;
  int xpos,ypos;
  unsigned int xsize,ysize,border,depth;

  XFetchName(dpy,top,&wname);
  XGetIconName(dpy,top,&iname);
  if (XGetClassHint(dpy,top,&classhint)==0) {
    classhint.res_name=NULL;
    classhint.res_class=NULL;
  }
  if (XGetGeometry(dpy,top,&foo,&xpos,&ypos,&xsize,&ysize,&border,&depth)==0) {
    xpos=ypos=0; xsize=ysize=border=0;
  }
  if (wname && *wname) { // do not show windows with no name
    if (xsize*ysize>100) { // only show windows with reasonably large size
//      listWidget_windows->addItem(QString("name=%2,iconname=%3,resname=%4,resclass=%5,x=%6,y=%7,w=%8,h=%9,window=%10").arg(wname).arg(iname).arg(classhint.res_name).arg(classhint.res_class).arg(xpos).arg(ypos).arg(xsize).arg(ysize).arg((int)top));

      int n,nitems;
      QTreeWidgetItem *thisitem;

      nitems=treeWidget_windows->topLevelItemCount();
      for (n=0; n<nitems; n++) { // check for duplicate item already in list
        thisitem=treeWidget_windows->topLevelItem(n);
        if (thisitem->text(0)==wname && thisitem->text(1)==classhint.res_class) { // duplicate item
          thisitem->setFlags(0); // set item to completely disabled
          break;
        }
      }
      if (n==nitems) { // if no duplicate item found
        QTreeWidgetItem *newItem=new QTreeWidgetItem();
        newItem->setText(0,wname);
        newItem->setText(1,classhint.res_class);
        treeWidget_windows->addTopLevelItem(newItem);
      }
    }
  }
  xfree(wname);
  xfree(iname);
  xfree(classhint.res_name);
  xfree(classhint.res_class);

  if (XQueryTree(dpy,top,&foo,&foo,&children,&nc)==0 || children==NULL) {
    return;
  }
  for (; nc>0; nc--) {
    listallwindows(children[nc-1]);
  }
  xfree(children);
  return;
}

void targetwindow::ListWindows(void)
{
  listallwindows(root);
}
#endif

